/**
 * Created by yaki on 7/18/2017.
 */

let _config = null;
function oneTimeSet(config){
    if(!_config){
        _config = config;
    }
}

class Config{

    static set set(config) {
        oneTimeSet(config);
    }

    static get get() {
        if(!_config){
            throw new Error('Config not set.\nUse Config.set = {your config} to set configurations');
        }
        return _config;
    }

    static getEnvironment(){
        let run_env =  Config.run_environments[process.env.NODE_ENV];
        if(!run_env){
            throw new Error('NODE_ENV environment variable was not set.\n' +
                'NODE_ENV = {PRODUCTION, STAGING, DEVELOPMENT}')
        }
        return run_env;
    }

    static mergeDefault(defaultConfig){
        //merge any default configuration to the costume environment config
        Object.keys(defaultConfig)
            .forEach(conf => _config[conf] = _config[conf] || defaultConfig[conf]);
    }
}

const envs = Config.envs = {
    PRODUCTION : 'production',
    STAGING : 'staging',
    DEVELOP : 'develop'
};



Config.run_environments = {
    PROD : envs.PRODUCTION,
    PRODUCTION : envs.PRODUCTION,
    STAGING : envs.STAGING,
    STG : envs.STAGING,
    DEVELOP : envs.DEVELOP,
    DEV : envs.DEVELOP
};

module.exports = Config;



